searchData={"items":[{"type":"module","title":"Circuits.UART","doc":"Find and use UARTs, serial ports, and more.","ref":"Circuits.UART.html"},{"type":"function","title":"Circuits.UART.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Circuits.UART.html#child_spec/1"},{"type":"function","title":"Circuits.UART.close/1","doc":"Close the serial port. The GenServer continues to run so that a port can\nbe opened again.","ref":"Circuits.UART.html#close/1"},{"type":"function","title":"Circuits.UART.configuration/1","doc":"Get the configuration of the serial port.","ref":"Circuits.UART.html#configuration/1"},{"type":"function","title":"Circuits.UART.configure/2","doc":"Change the serial port configuration after `open/3` has been called. See\n`open/3` for the valid options.","ref":"Circuits.UART.html#configure/2"},{"type":"function","title":"Circuits.UART.controlling_process/2","doc":"Change the controlling process that\nreceives events from an active uart.","ref":"Circuits.UART.html#controlling_process/2"},{"type":"function","title":"Circuits.UART.drain/1","doc":"Waits until all data has been transmitted. See\n[tcdrain(3)](http://linux.die.net/man/3/tcdrain) for low level details on\nLinux or OSX. This is not implemented on Windows.","ref":"Circuits.UART.html#drain/1"},{"type":"function","title":"Circuits.UART.enumerate/0","doc":"Return a map of available ports with information about each one. The map\nlooks like this:\n\n```elixir\n %{\"ttyS0\" -> %{vendor_id: 1234, product_id: 1,\n                manufacturer: \"Acme Corporation\", serial_number: \"000001\"},\n   \"ttyUSB0\" -> %{vendor_id: 1234, product_id: 2}}\n```\n\nDepending on the port and the operating system, not all fields may be\nreturned. Informational fields are:\n\n* `:vendor_id` - The 16-bit USB vendor ID of the device providing the port. Vendor ID to name lists are managed through usb.org\n* `:product_id` - The 16-bit vendor supplied product ID\n* `:manufacturer` - The manufacturer of the port\n* `:description` - A description or product name\n* `:serial_number` - The device's serial number if it has one","ref":"Circuits.UART.html#enumerate/0"},{"type":"function","title":"Circuits.UART.find_pids/0","doc":"Find UARTs.\n\nThis is intended as a diagnostic function for finding UARTs that you may have\nopened and forgotten about. Since a UART can only be opened once, this helps\nyou find the problematic one so that you can close it.\n\nIt returns a list of {pid, uart_name} tuples.\n\nNOTE: Do not rely on this function in production code. It may change if\nupdates to the interface make it more convenient to use.","ref":"Circuits.UART.html#find_pids/0"},{"type":"function","title":"Circuits.UART.flush/2","doc":"Flushes the `:receive` buffer, the `:transmit` buffer, or `:both`.\n\nSee [tcflush(3)](http://linux.die.net/man/3/tcflush) for low level details on\nLinux or OSX. This calls `PurgeComm` on Windows.","ref":"Circuits.UART.html#flush/2"},{"type":"function","title":"Circuits.UART.init/1","doc":"Callback implementation for  GenServer.init/1 .","ref":"Circuits.UART.html#init/1"},{"type":"function","title":"Circuits.UART.open/3","doc":"Open a serial port.\n\nThe following options are available:\n\n* `:active` - (`true` or `false`) specifies whether data is received as\n   messages or by calling `read/2`. See discussion below.\n\n* `:speed` - (number) set the initial baudrate (e.g., 115200)\n\n* `:data_bits` - (5, 6, 7, 8) set the number of data bits (usually 8)\n\n* `:stop_bits` - (1, 2) set the number of stop bits (usually 1)\n\n* `:parity` - (`:none`, `:even`, `:odd`, `:space`, or `:mark`) set the\n  parity. Usually this is `:none`. Other values:\n  * `:space` means that the parity bit is always 0\n  * `:mark` means that the parity bit is always 1\n  * `:ignore` means that the parity bit is ignored (Linux/OSX only)\n\n* `:flow_control` - (`:none`, `:hardware`, or `:software`) set the flow control\n  strategy.\n\n* `:framing` - (`module` or `{module, args}`) set the framing for data.\n  The `module` must implement the `Circuits.UART.Framing` behaviour. See\n  `Circuits.UART.Framing.None`, `Circuits.UART.Framing.Line`, and\n  `Circuits.UART.Framing.FourByte`. The default is `Circuits.UART.Framing.None`.\n\n* `:rx_framing_timeout` - (milliseconds) this specifies how long incomplete\n  frames will wait for the remainder to be received. Timed out partial\n  frames are reported as `{:partial, data}`. A timeout of <= 0 means to\n  wait forever.\n\n* `:id` - (`:name` or `:pid`) specify what to return with the uart active\n  messages. with `:name` the messages are returned as `{:circuits_uart,\n  serial_port_name, data}` otherwise they are returned as `{:circuits_uart,\n  pid, data}`. The name and pid are the name of the connected UART or the pid\n  of the Circuits.UART server pid as returned by `start_link/1`. The default\n  value is `:name`.\n\nThe following options are supported on Linux only:\n\n* `:rs485_enabled` - (`true` or `false`) enable RS485 mode.\n* `:rs485_rts_on_send` - (`true` or `false`) enable RTS on send.\n* `:rs485_rts_after_send` - (`true` or `false`) enable RTS after send.\n* `:rs485_rx_during_tx` - (`true` or `false`) enable RX during TX (loopback).\n* `:rs485_terminate_bus` - (`true` or `false`) enable bus termination.\n* `:rs485_delay_rts_before_send` - (milliseconds) delay RTS before send.\n* `:rs485_delay_rts_after_send` - (milliseconds) delay RTS after send.\n\nActive mode defaults to true and means that data received on the UART is\nreported in messages. The messages have the following form:\n\n```elixir\n{:circuits_uart, serial_port_id, data}\n```\n\nor\n\n```elixir\n{:circuits_uart, serial_port_id, {:error, reason}}\n```\n\nWhen in active mode, flow control can not be used to push back on the sender\nand messages will accumulated in the mailbox should data arrive fast enough.\nIf this is an issue, set `:active` to false and call `read/2` manually when\nready for more data.\n\nOn success, `open/3` returns `:ok`. On error, `{:error, reason}` is returned.\nThe following are some reasons:\n\n* `:enoent`  - the specified port couldn't be found\n* `:eagain`  - the port is already open\n* `:eacces`  - permission was denied when opening the port","ref":"Circuits.UART.html#open/3"},{"type":"function","title":"Circuits.UART.read/2","doc":"Read data from the UART. This call returns data as soon as it's available or\nafter timing out.\n\nReturns `{:ok, binary}`, where `binary` is a binary data object that contains the\nread data, `{:error, reason}` if an error occurs, or `{:ok, <<>>}` after timing out.\n\nTypical error reasons:\n\n* `:ebadf` - the UART is closed\n* `:einval` - the UART is in active mode","ref":"Circuits.UART.html#read/2"},{"type":"function","title":"Circuits.UART.send_break/2","doc":"Send a continuous stream of zero bits for a duration in milliseconds.\nBy default, the zero bits are transmitted at least 0.25 seconds.\n\nThis is a convenience function for calling `set_break/2` to enable\nthe break signal, wait, and then turn it off.","ref":"Circuits.UART.html#send_break/2"},{"type":"function","title":"Circuits.UART.set_break/2","doc":"Start or stop sending a break signal.","ref":"Circuits.UART.html#set_break/2"},{"type":"function","title":"Circuits.UART.set_dtr/2","doc":"Set or clear the Data Terminal Ready signal.","ref":"Circuits.UART.html#set_dtr/2"},{"type":"function","title":"Circuits.UART.set_rts/2","doc":"Set or clear the Request To Send signal.","ref":"Circuits.UART.html#set_rts/2"},{"type":"function","title":"Circuits.UART.signals/1","doc":"Returns a map of signal names and their current state (true or false).\nSignals include:\n\n* `:dsr` - Data Set Ready\n* `:dtr` - Data Terminal Ready\n* `:rts` - Request To Send\n* `:st`  - Secondary Transmitted Data\n* `:sr`  - Secondary Received Data\n* `:cts` - Clear To Send\n* `:cd`  - Data Carrier Detect\n* `:rng` - Ring Indicator","ref":"Circuits.UART.html#signals/1"},{"type":"function","title":"Circuits.UART.start_link/1","doc":"Start up a UART GenServer.\n\nYou usually don't need to pass options here unless you'd like to register a\nname for the GenServer.  See `open/3` for opening all of the configuration\noptions.","ref":"Circuits.UART.html#start_link/1"},{"type":"function","title":"Circuits.UART.stop/1","doc":"Stop the UART GenServer.","ref":"Circuits.UART.html#stop/1"},{"type":"type","title":"Circuits.UART.uart_option/0","doc":"","ref":"Circuits.UART.html#t:uart_option/0"},{"type":"function","title":"Circuits.UART.write/3","doc":"Write data to the opened UART. It's possible for the write to return before all\nof the data is actually transmitted. To wait for the data, call drain/1.\n\nThis call blocks until all of the data to be written is in the operating\nsystem's internal buffers. If you're sending a lot of data on a slow link,\nsupply a longer timeout to avoid timing out prematurely.\n\nReturns `:ok` on success or `{:error, reason}` if an error occurs.\n\nTypical error reasons:\n\n* `:ebadf` - the UART is closed","ref":"Circuits.UART.html#write/3"},{"type":"behaviour","title":"Circuits.UART.Framing","doc":"A behaviour for implementing framers for data received over a UART.","ref":"Circuits.UART.Framing.html"},{"type":"callback","title":"Circuits.UART.Framing.add_framing/2","doc":"Add framing to the passed in data.\n\nThe returned `frame_data` will be sent out the UART.","ref":"Circuits.UART.Framing.html#c:add_framing/2"},{"type":"callback","title":"Circuits.UART.Framing.flush/2","doc":"This is called when the user invokes `Circuits.UART.flush/2`. Any partially\nreceived frames should be dropped.","ref":"Circuits.UART.Framing.html#c:flush/2"},{"type":"callback","title":"Circuits.UART.Framing.frame_timeout/1","doc":"If `remove_framing/2` returned `:in_frame` and a user-specified timeout for\nreassembling frames has elapsed, then this function is called. Depending on\nthe semantics of the framing, a partial frame may be returned or the\nincomplete frame may be dropped.","ref":"Circuits.UART.Framing.html#c:frame_timeout/1"},{"type":"callback","title":"Circuits.UART.Framing.init/1","doc":"Initialize the state of the framer based on options passed to\n`Circuits.UART.open/3`.\n\nThis function should return the initial state for the framer or\nan error.","ref":"Circuits.UART.Framing.html#c:init/1"},{"type":"callback","title":"Circuits.UART.Framing.remove_framing/2","doc":"Remove the framing off received data. If a partial frame is left over at the\nend, then `:in_frame` should be returned. All of the frames received should\nbe returned in the second tuple.\n\nThe terms returned as the second part of the tuple can be anything. They can be\nthe binary messages without the framing, structs based on your commands, or anything\nelse. If you have errors in the protocol, for example a bad checksum, one convention\nis to return an error tuple `{:error, :echksum, message}`.\nFor debugging you may want to include the message and framing with the error for\nsimpler debugging.","ref":"Circuits.UART.Framing.html#c:remove_framing/2"},{"type":"module","title":"Circuits.UART.Framing.FourByte","doc":"Each message is 4 bytes. This framer doesn't do anything for the transmit\ndirection, but for receives, it will collect bytes in batches of 4 before\nsending them up. The user can set up a framer timeout if they don't mind\npartial frames. This can be useful to resyncronize when bytes are dropped.","ref":"Circuits.UART.Framing.FourByte.html"},{"type":"function","title":"Circuits.UART.Framing.FourByte.add_framing/2","doc":"Callback implementation for  Circuits.UART.Framing.add_framing/2 .","ref":"Circuits.UART.Framing.FourByte.html#add_framing/2"},{"type":"function","title":"Circuits.UART.Framing.FourByte.flush/2","doc":"Callback implementation for  Circuits.UART.Framing.flush/2 .","ref":"Circuits.UART.Framing.FourByte.html#flush/2"},{"type":"function","title":"Circuits.UART.Framing.FourByte.frame_timeout/1","doc":"Callback implementation for  Circuits.UART.Framing.frame_timeout/1 .","ref":"Circuits.UART.Framing.FourByte.html#frame_timeout/1"},{"type":"function","title":"Circuits.UART.Framing.FourByte.init/1","doc":"Callback implementation for  Circuits.UART.Framing.init/1 .","ref":"Circuits.UART.Framing.FourByte.html#init/1"},{"type":"function","title":"Circuits.UART.Framing.FourByte.remove_framing/2","doc":"Callback implementation for  Circuits.UART.Framing.remove_framing/2 .","ref":"Circuits.UART.Framing.FourByte.html#remove_framing/2"},{"type":"module","title":"Circuits.UART.Framing.Line","doc":"Each message is one line. This framer appends and removes newline sequences\nas part of the framing. Buffering is performed internally, so users can get\nthe complete messages under normal circumstances. Attention should be paid\nto the following:\n\n1. Lines must have a fixed max length so that a misbehaving sender can't\n   cause unbounded buffer expansion. When the max length is passed, a\n   `{:partial, data}` is reported. The application can decide what to do with\n   this.\n2. The separation character varies depending on the target device. See\n   \"Separator\" section to see how to specify this.\n3. It may be desirable to set a `:rx_framing_timeout` to prevent\n   characters received in error from collecting during idle times. When the\n   receive timer expires, `{:partial, data}` is reported.\n4. Line separators must be ASCII characters (0-127) or be valid UTF-8\n   sequences. If the device only sends ASCII, high characters (128-255)\n   should work as well. [Note: please report if using extended\n   characters.]","ref":"Circuits.UART.Framing.Line.html"},{"type":"module","title":"Separator - Circuits.UART.Framing.Line","doc":"Some devices require `\"\\r\\n\"` sequences. If you are using one of these\ndevices, a LTE modem for example, you can specify the separator like so:\n\n```elixir\nCircuits.UART.open(uart, tty_name, framing: {Circuits.UART.Framing.Line, separator: \"\\r\\n\"})\n```\n\nBy default the separator is `\"\\n\"`. Currently only one or two character\nseparators are supported.","ref":"Circuits.UART.Framing.Line.html#module-separator"},{"type":"function","title":"Circuits.UART.Framing.Line.add_framing/2","doc":"Callback implementation for  Circuits.UART.Framing.add_framing/2 .","ref":"Circuits.UART.Framing.Line.html#add_framing/2"},{"type":"function","title":"Circuits.UART.Framing.Line.buffer_empty?/1","doc":"","ref":"Circuits.UART.Framing.Line.html#buffer_empty?/1"},{"type":"function","title":"Circuits.UART.Framing.Line.flush/2","doc":"Callback implementation for  Circuits.UART.Framing.flush/2 .","ref":"Circuits.UART.Framing.Line.html#flush/2"},{"type":"function","title":"Circuits.UART.Framing.Line.frame_timeout/1","doc":"Callback implementation for  Circuits.UART.Framing.frame_timeout/1 .","ref":"Circuits.UART.Framing.Line.html#frame_timeout/1"},{"type":"function","title":"Circuits.UART.Framing.Line.init/1","doc":"Callback implementation for  Circuits.UART.Framing.init/1 .","ref":"Circuits.UART.Framing.Line.html#init/1"},{"type":"function","title":"Circuits.UART.Framing.Line.remove_framing/2","doc":"Callback implementation for  Circuits.UART.Framing.remove_framing/2 .","ref":"Circuits.UART.Framing.Line.html#remove_framing/2"},{"type":"module","title":"Circuits.UART.Framing.None","doc":"Don't apply or removing any framing.","ref":"Circuits.UART.Framing.None.html"},{"type":"function","title":"Circuits.UART.Framing.None.add_framing/2","doc":"Callback implementation for  Circuits.UART.Framing.add_framing/2 .","ref":"Circuits.UART.Framing.None.html#add_framing/2"},{"type":"function","title":"Circuits.UART.Framing.None.flush/2","doc":"Callback implementation for  Circuits.UART.Framing.flush/2 .","ref":"Circuits.UART.Framing.None.html#flush/2"},{"type":"function","title":"Circuits.UART.Framing.None.frame_timeout/1","doc":"Callback implementation for  Circuits.UART.Framing.frame_timeout/1 .","ref":"Circuits.UART.Framing.None.html#frame_timeout/1"},{"type":"function","title":"Circuits.UART.Framing.None.init/1","doc":"Callback implementation for  Circuits.UART.Framing.init/1 .","ref":"Circuits.UART.Framing.None.html#init/1"},{"type":"function","title":"Circuits.UART.Framing.None.remove_framing/2","doc":"Callback implementation for  Circuits.UART.Framing.remove_framing/2 .","ref":"Circuits.UART.Framing.None.html#remove_framing/2"},{"type":"extras","title":"Circuits.UART","doc":"# Circuits.UART\n\n[![Hex version](https://img.shields.io/hexpm/v/circuits_uart.svg \"Hex version\")](https://hex.pm/packages/circuits_uart)\n[![API docs](https://img.shields.io/hexpm/v/circuits_uart.svg?label=hexdocs \"API docs\")](https://hexdocs.pm/circuits_uart/Circuits.UART.html)\n[![CI](https://github.com/elixir-circuits/circuits_uart/actions/workflows/ci.yml/badge.svg)](https://github.com/elixir-circuits/circuits_uart/actions/workflows/ci.yml)\n[![REUSE status](https://api.reuse.software/badge/github.com/elixir-circuits/circuits_uart)](https://api.reuse.software/info/github.com/elixir-circuits/circuits_uart)\n\n`Circuits.UART` allows you to use UARTs, serial ports, Bluetooth virtual serial\nport connections and more in Elixir. Some highlights:\n\n* Mac, Windows, Linux, and Nerves\n* Enumerate serial ports\n* Receive input via messages or by polling (active and passive modes)\n* Add and remove framing on serial data - line-based framing included for use\n  with GPS, cellular, satellite and other modules\n* Unit tests (uses the [tty0tty](https://github.com/freemed/tty0tty) virtual\n  null modem)\n\nLooking for `Nerves.UART`? `Circuits.UART` is the new name. Everything else is\nthe same. Update your project by replacing all references to `nerves_uart` and\n`Nerves.UART` to `circuits_uart` and `Circuits.UART` and you should be good.\n\nSomething doesn't work for you? Check out below and the\n[docs](https://hexdocs.pm/circuits_uart/). Post a question on the [Elixir\nForum](https://elixirforum.com/) or file an issue or PR.","ref":"readme.html"},{"type":"extras","title":"Example use - Circuits.UART","doc":"Discover what serial ports are attached:\n\n```elixir\niex> Circuits.UART.enumerate\n%{\"COM14\" => %{description: \"USB Serial Port\", manufacturer: \"FTDI\", product_id: 24577,\n    vendor_id: 1027},\n  \"COM5\" => %{description: \"Prolific USB-to-Serial Comm Port\",\n    manufacturer: \"Prolific\", product_id: 8963, vendor_id: 1659},\n  \"COM16\" => %{description: \"Arduino Uno\",\n    manufacturer: \"Arduino LLC (www.arduino.cc)\", product_id: 67, vendor_id: 9025}}\n```\n\nStart the UART GenServer:\n\n```elixir\niex> {:ok, pid} = Circuits.UART.start_link\n{:ok, #PID<0.132.0>}\n```\n\nThe GenServer doesn't open a port automatically, so open up a serial port or\nUART now. See the results from your call to `Circuits.UART.enumerate/0` for what's\navailable on your system.\n\n```elixir\niex> Circuits.UART.open(pid, \"COM14\", speed: 115200, active: false)\n:ok\n```\n\nThis opens the serial port up at 115200 baud and turns off active mode. This\nmeans that you'll have to manually call `Circuits.UART.read` to receive input. In\nactive mode, input from the serial port will be sent as messages. See the docs\nfor all options.\n\nWrite something to the serial port:\n\n```elixir\niex> Circuits.UART.write(pid, \"Hello there\\r\\n\")\n:ok\n```\n\nSee if anyone responds in the next 60 seconds:\n\n```elixir\niex> Circuits.UART.read(pid, 60000)\n{:ok, \"Hi\"}\n```\n\nInput is reported as soon as it is received, so you may need multiple calls to\n`read/2` to get everything you want. If you have flow control enabled and stop\ncalling `read/2`, the port will push back to the sender when its buffers fill\nup.\n\nEnough with passive mode, let's switch to active mode:\n\n```elixir\niex> Circuits.UART.configure(pid, active: true)\n:ok\n\niex> flush\n{:circuits_uart, \"COM14\", \"a\"}\n{:circuits_uart, \"COM14\", \"b\"}\n{:circuits_uart, \"COM14\", \"c\"}\n{:circuits_uart, \"COM14\", \"\\r\"}\n{:circuits_uart, \"COM14\", \"\\n\"}\n:ok\n```\n\nIt turns out that `COM14` is a USB to serial port. Let's unplug it and see what\nhappens:\n\n```elixir\niex> flush\n{:circuits_uart, \"COM14\", {:error, :eio}}\n```\n\nOops. Well, when it appears again, it can be reopened. In passive mode, errors\nget reported on the calls to `Circuits.UART.read/2` and `Circuits.UART.write/3`\n\nBack to receiving data, it's a little annoying that characters arrive one by\none.  That's because our computer is really fast compared to the serial port,\nbut if something slows it down, we could receive two or more characters at a\ntime. Rather than reassemble the characters into lines, we can ask `circuits_uart`\nto do it for us:\n\n```elixir\niex> Circuits.UART.configure(pid, framing: {Circuits.UART.Framing.Line, separator: \"\\r\\n\"})\n:ok\n```\n\nThis tells `circuits_uart` to append a `\\r\\n` to each call to `write/2` and to\nreport each line separately in active and passive mode. You can set this\nconfiguration in the call to `open/3` as well. Here's what we get now:\n\n```elixir\niex> flush\n{:circuits_uart, \"COM14\", \"abc\"}   # Note that the \"\\r\\n\" is trimmed\n:ok\n```\n\nIf your serial data is framed differently, check out the `Circuits.UART.Framing`\nbehaviour and implement your own. `Circuits.UART.Framing.FourByte` is a\nparticularly simple example of a framer.\n\nYou can also set a timeout so that a partial line doesn't hang around in the\nreceive buffer forever:\n\n```elixir\niex> Circuits.UART.configure(pid, rx_framing_timeout: 500)\n:ok\n\n# Assume that the sender sent the letter \"A\" without sending anything else\n# for 500 ms.\n\niex> flush\n{:circuits_uart, \"COM14\", {:partial, \"A\"}}\n```\n\nSometimes it's easier to operate with the `pid` of the UART GenServer rather\nthan using the name of the port in active mode. An example of this is when you\nwant to send an acknowledgment back after a receive and you are using more than\none serial port at a time. You can do this with the `id: :pid` option to\n`open/1` or `configure/1`.\n\n```elixir\niex> Circuits.UART.configure(pid, id: :pid)\n:ok\n\n# Assume some data was received\n\niex> receive do\n...>   {:circuits_uart, pid, _} ->\n...>     Circuits.UART.write(pid, \"ack\")\n...> end\n:ok\n```","ref":"readme.html#example-use"},{"type":"extras","title":"Installation - Circuits.UART","doc":"To install `circuits_uart`:\n\n  1. Add `circuits_uart` to your list of dependencies in `mix.exs`:\n\n  ```elixir\n  def deps do\n    [{:circuits_uart, \"~> 1.5\"}]\n  end\n  ```\n\n  1. Check that the C compiler dependencies are satisified (see below)\n\n  1. Run `mix deps.get` and `mix compile`","ref":"readme.html#installation"},{"type":"extras","title":"C compiler dependencies - Circuits.UART","doc":"Since this library includes C code, `make`, `gcc`, and Erlang header and\ndevelopment libraries are required.\n\nOn Linux systems, this usually requires you to install the `build-essential` and\n`erlang-dev` packages. For example:\n\n```sh\nsudo apt-get install build-essential erlang-dev\n```\n\nOn Macs, run `gcc --version` or `make --version`. If they're not installed, you\nwill be given instructions.\n\nOn Windows, if you're obtaining `circuits_uart` from `hex.pm`, you'll need MinGW\nto compile the C code. I use [Chocolatey](https://chocolatey.org/) and install\nMinGW by running the following in an administrative command prompt:\n\n```sh\nchoco install mingw\n```\n\nOn Nerves, you're set - just add `circuits_uart` to your `mix.exs`. Nerves\ncontains everything needed by default. If you do use Nerves, though, keep in\nmind that the C code is crosscompiled for your target hardware and will not work\non your host (the port will crash when you call `start_link` or `enumerate`. If\nyou want to try out `circuits_uart` on your host machine, the easiest way is to\neither clone the source or add `circuits_uart` as a dependency to a regular\n(non-Nerves) Elixir project.","ref":"readme.html#c-compiler-dependencies"},{"type":"extras","title":"Building and running the unit tests - Circuits.UART","doc":"The standard Elixir build process applies. Clone `circuits_uart` or download a\nsource release and run:\n\n```sh\nmix deps.get\nmix compile\n```\n\nThe unit tests require two serial ports connected via a NULL modem cable to run.\nDefine the names of the serial ports in the environment before running the\ntests. For example,\n\n```sh\nexport CIRCUITS_UART_PORT1=ttyS0\nexport CIRCUITS_UART_PORT2=ttyS1\n```\n\nIf you're on Windows or Linux, you don't need real serial ports. For linux,\ndownload and install [tty0tty](https://github.com/freemed/tty0tty). Load the\nkernel module and specify `tnt0` and `tnt1` for the serial ports. Check the\n`tty0tty` README.md, but this should looks something like:\n\n```sh\ncd tty0tty/module\nmake\nsudo cp tty0tty.ko /lib/modules/$(uname -r)/kernel/drivers/misc/\nsudo depmod\nsudo modprobe tty0tty\nsudo chmod 666 /dev/tnt*\n\nexport CIRCUITS_UART_PORT1=tnt0\nexport CIRCUITS_UART_PORT2=tnt1\n```\n\nOn Windows, download and install\n[com0com](https://sourceforge.net/projects/com0com/) (Look for version 2.2.2.0\nif the latest hasn't been signed). The ports on Windows are `CNCA0` and `CNCB0`.\n\nThen run:\n\n```sh\nmix test\n```\n\nIf you're using `tty0tty`, the tests will run at full speed. Real serial ports\nseem to take a fraction of a second to close and re-open. I added a gratuitous\ndelay to each test to work around this. It likely can be much shorter.\n\n\nOn MacOS, download and install [socat](http://www.dest-unreach.org/socat/). You can install it via Homebrew. Once you have it installed and ready to go, run the following command. You will need to change ` ` to your current system username\n\n```sh\nsudo socat -d -d -d -d -lf /tmp/socat pty,link=/dev/dummy1,raw,echo=0,user= ,group=staff link=/dev/dummy2,raw,echo=0,user= ,group=staff\n```\n\nOnce that opens, in a separate terminal emulator, set the Circuits ENVars, and go about your testing\n\n```sh\nexport CIRCUITS_UART_PORT1=/dev/dummy1\nexport CIRCUITS_UART_PORT2=/dev/dummy2\nmix test\n```","ref":"readme.html#building-and-running-the-unit-tests"},{"type":"extras","title":"FAQ - Circuits.UART","doc":"","ref":"readme.html#faq"},{"type":"extras","title":"Do I have to use Nerves? - Circuits.UART","doc":"No, this project doesn't have any dependencies on any Nerves components. The\ndesire for some serial port library features on Nerves drove us to create it,\nbut we also have host-based use cases. To be useful for us, the library must\nremain crossplatform and have few dependencies. We're just developing it under\nthe Nerves umbrella.","ref":"readme.html#do-i-have-to-use-nerves"},{"type":"extras","title":"How can I use the serial port on Linux without sudo? - Circuits.UART","doc":"Serial port files are almost always owned by the `dialout` group. Add yourself\nto the `dialout` group by running `sudo adduser yourusername dialout`. Then log\nout and back in again, and you should be able to access the serial port.","ref":"readme.html#how-can-i-use-the-serial-port-on-linux-without-sudo"},{"type":"extras","title":"Debugging tips - Circuits.UART","doc":"If you're having trouble and suspect the C code, edit the `Makefile` to enable\ndebug logging. See the `Makefile` for instructions on how to do this. Debug\nlogging is appended to a file by default, but can be sent to `stderr` or another\nlocation by editing `src/circuits_uart.c`.\n\nIf you're on Linux, the `tty0tty` emulated null modem removes the flakiness of\nreal serial port drivers if that's the problem. The serial port monitor\n[jpnevulator](https://jpnevulator.snarl.nl/) is useful for monitoring the\nhardware signals and dumping data as hex byte values.\n\nOn OSX and Windows, I've found that PL2303-based serial ports can be flakey.\nFirst, make sure that you don't have a counterfeit PL2303. On Windows, they show\nup in device manager with a warning symbol. On OSX, they seem to hang when\nclosing the port. Non-counterfeit PL2303-based serial ports can pass the unit\ntests on Windows 10, but I have not been able to get them to pass on OSX.\nFTDI-based serial ports appear to work better on both operating systesm.","ref":"readme.html#debugging-tips"},{"type":"extras","title":"ei_copy why???? - Circuits.UART","doc":"You may have noticed Erlang's `erl_interface` code copy/pasted into\n`src/ei_copy`.  This is *only* used on Windows to work around issues linking to\nthe distributed version of `erl_interface`. That was compiled with Visual\nStudio. This project uses MinGW, and even though the C ABIs are the same between\nthe compilers, Visual Studio adds stack protection calls that I couldn't figure\nout how to work around.","ref":"readme.html#ei_copy-why"},{"type":"extras","title":"How does Circuits.UART communicate with the serial port? - Circuits.UART","doc":"Circuits.UART uses a [Port](https://hexdocs.pm/elixir/Port.html) and C code.\nElixir/Erlang ports have nothing to do with the serial ports of the operating\nsystem.  They share the same name but are different concepts.","ref":"readme.html#how-does-circuits-uart-communicate-with-the-serial-port"},{"type":"extras","title":"I see weird things happening on my UART using nerves - Circuits.UART","doc":"By default nerves is configured so Linux and the Elixir console is redirected\nto the serial0 interface. As a result, while using this interface, the buffer might\nbe full of debug logs from your application, which could cause the port to timeout\nwhen you are writing to it, or attempting to drain it `:port_timed_out`.\n\nTo disable this \"pollution\" you will have to edit:\n- `erlinit.config` and comment `-c ttyAMA0`\n- `cmdline.txt` and comment `console=serial0,115200`\n\nTo learn how to edit those files in your nerves setup you can check the advanced\nconfiguration documentation of nerves:\nhttps://hexdocs.pm/nerves/advanced-configuration.html#overwriting-files-in-the-root-filesystem","ref":"readme.html#i-see-weird-things-happening-on-my-uart-using-nerves"},{"type":"extras","title":"Acknowledgments - Circuits.UART","doc":"When building this library,\n[node-serialport](https://github.com/voodootikigod/node-serialport) and\n[QtSerialPort](http://doc.qt.io/qt-5/qserialport.html) where incredibly helpful\nin helping to define APIs and point out subtleties with platform-specific serial\nport code. Sadly, I couldn't reuse their code, but I feel indebted to the\nauthors and maintainers of these libraries, since they undoubtedly saved me\nhours of time debugging corner cases.  I have tried to acknowledge them in the\ncomments where I have used strategies that I learned from them.","ref":"readme.html#acknowledgments"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n*I'm looking for help maintaining Circuits.UART. While it generally can be made\nto do what people want, there are some significant improvements that are\npossible that would be really nice to have. I just haven't had a project to\njustify them and don't have time. Please consider reaching out if you have time\nand interest.*","ref":"changelog.html"},{"type":"extras","title":"v1.5.5 - Changelog","doc":"* Fixes\n  * Increase max transfer size from slightly under 16 KB to 32 KB. Thanks to\n    @ewildgoose for this fix.","ref":"changelog.html#v1-5-5"},{"type":"extras","title":"v1.5.4 - Changelog","doc":"* Fixes\n  * Fix continue_in_progress_write() pointer error that when hit would likely\n    include random bursts of 0s in the data stream. Thanks to @ewildgoose for\n    this fix.\n\n* Updates\n  * Update copyright and license info for [REUSE compliance](https://reuse.software/)","ref":"changelog.html#v1-5-4"},{"type":"extras","title":"v1.5.3 - Changelog","doc":"* Fixes\n  * Fix compilation when Erlang has been installed to a directory with spaces","ref":"changelog.html#v1-5-3"},{"type":"extras","title":"v1.5.2 - Changelog","doc":"* Fixes\n  * Fix `Circuits.UART.read/2` spec. Thanks to @codestorm1.","ref":"changelog.html#v1-5-2"},{"type":"extras","title":"v1.5.1 - Changelog","doc":"* Fixes\n  * Don't even try using the RS485 ioctls if not set by the user. This fixes an\n    issue on Allwinner devices, but probably others, where getting RS485\n    settings works, but setting them, even if unchanged always fails. Thanks to\n    @jjcarstens for the fix.","ref":"changelog.html#v1-5-1"},{"type":"extras","title":"v1.5.0 - Changelog","doc":"* Updates\n  * Added RS485 configuration options. These only work on Linux. Thanks to\n    @jjcarstens for this feature.","ref":"changelog.html#v1-5-0"},{"type":"extras","title":"v1.4.5 - Changelog","doc":"* Bug fix\n  * Gracefully handle Process.info/2 returning nil (:heart: @tonnenpinguin)","ref":"changelog.html#v1-4-5"},{"type":"extras","title":"v1.4.4 - Changelog","doc":"* Improvements\n  * Fix MacOS deprecation warning. Thanks to @tonnenpinguin for the fix.","ref":"changelog.html#v1-4-4"},{"type":"extras","title":"v1.4.3 - Changelog","doc":"This release doesn't contain any new features. Most of the changes relate to\nupdating dependencies and CI to make the project more pleasant to maintain.\n\n* Improvements\n  * Minor documentation fixes and build message cleanup.","ref":"changelog.html#v1-4-3"},{"type":"extras","title":"v1.4.2 - Changelog","doc":"* Bug fix\n  * Updated non-standard UART speed configuration to use the newer termios2 API\n    on Linux. This fixes a custom speed issue that was seen when using the older\n    API. Thanks to Tom Boland for reporting the issue and providing a fix.","ref":"changelog.html#v1-4-2"},{"type":"extras","title":"v1.4.1 - Changelog","doc":"* Bug fix\n  * Remove unneeded `terminate/2` that could crash under some situations.","ref":"changelog.html#v1-4-1"},{"type":"extras","title":"v1.4.0 - Changelog","doc":"* New Feature\n  * Add `Circuits.UART.controlling_process/2`. This assigns a new controlling\n    process Pid to a uart in similar to OTP functions like\n   `:gen_udp.controlling_process/2`. Thanks to Robin Hilliard for adding this.","ref":"changelog.html#v1-4-0"},{"type":"extras","title":"v1.3.2 - Changelog","doc":"* Bug fixes\n  * Fix incorrect switch in C that caused flow control enum to be incorrect.\n    Thanks to Lee Bannard","ref":"changelog.html#v1-3-2"},{"type":"extras","title":"v1.3.1 - Changelog","doc":"* Bug fixes\n  * Lengthen timeouts on messages sent to ports. This provides more slack time\n    on heavily loaded uniprocessor devices that were missing timeouts by ~100 ms\n    periodically.\n  * Move C object files and the port executable to under the `_build` directory.\n    This makes it easier to switch between host/target builds especially when\n    using Elixir 1.8's mix target feature.\n\n* Improvements\n  * Handle iodata on `Circuits.UART.write` in addition to binaries and\n    charlists.","ref":"changelog.html#v1-3-1"},{"type":"extras","title":"v1.3.0 - Changelog","doc":"Rebrand to `Circuits.UART`. No features or bugs were fixed in this version. To\nupgrade, you will need to rename all occurences of `nerves_uart` to\n`circuits_uart` and `Nerves.UART` to `Circuits.UART`.","ref":"changelog.html#v1-3-0"},{"type":"extras","title":"v1.2.1 - Changelog","doc":"* Bug fixes\n  * Added missing ignore parity option to parity checking choices\n  * Fix compiler warnings when built using newer versions of gcc","ref":"changelog.html#v1-2-1"},{"type":"extras","title":"v1.2.0 - Changelog","doc":"* Improvements\n  * Added `id: pid` option. In active mode, this causes the receive\n    notification messages to contain the pid of the Circuits.UART GenServer that\n    sends them. Thanks to Tallak Tveide for this improvement.\n  * Added `find_pids/0` diagnostic utility for finding lost `Circuits.UART` pids.\n    This is handy when you need to close a serial port and don't know the pid.\n  * Added `configuration/1` to get the current configuration of a UART.","ref":"changelog.html#v1-2-0"},{"type":"extras","title":"v1.1.1 - Changelog","doc":"The mix.exs file has the Elixir requirement bumped from 1.3 to 1.4. This was\ndone to fix a Dialyzer warning caused by a change in arguments to\n`System.monotonic_time/1` with newer versions of Erlang and Elixir.\nUnfortunately this broke compilation under Elixir 1.3.\n\n* Bug fixes\n  * Removed unnecessary open failure notification message. The failure gets\n    returned from the open call already and the notification was due to an\n    unfortunate path through the Linux file handle polling code.\n  * Various Windows fixes:\n    * Fixed unhandled tx ready event seen during big transfers at 250000.\n      Thanks to Arne Ehrlich for figuring this out.\n    * Fixed bogus file handle errors when an open fails and then an attempt to\n      open again happens without a restart of the GenServer.","ref":"changelog.html#v1-1-1"},{"type":"extras","title":"v1.1.0 - Changelog","doc":"* Improvements\n  * Added 4-byte framer both since it is periodically useful and as a very\n    simple example of the framing feature.\n\n* Bug fixes\n  * Fix active mode state not being updated and a message being sent in\n    passive mode on an open failure.\n  * Maintain the elapsed time on passive mode reads to avoid reading forever\n    when bytes keep arriving, but no messages get sent from the framer","ref":"changelog.html#v1-1-0"},{"type":"extras","title":"v1.0.1 - Changelog","doc":"* Improvements\n  * Refactored Makefile logic to avoid 1-2 second hit when building. This was\n    due to erl being called to get the directory containing the erl interface\n    include/lib paths. Now mix.exs passes them down.\n  * Trivial Elixir 1.6 formatting tweaks","ref":"changelog.html#v1-0-1"},{"type":"extras","title":"v1.0.0 - Changelog","doc":"* Bug fixes\n  * Flush framing when closing a port\n  * Fix broken spec's\n  * Documentation and code cleanup","ref":"changelog.html#v1-0-0"},{"type":"extras","title":"v0.1.2 - Changelog","doc":"Prebuilt port binaries are no longer distributed in hex.pm for Windows users.\nYou'll need to install MinGW. Feedback was that it didn't work as well as I\nthought it would.\n\n* Bug fixes\n  * Fix custom baudrates not working on OSX. Thanks to salzig for identifying\n    the problem and helping to debug it.\n  * Pass flush request through to framer as well as the serial port\n  * Minor code cleanup","ref":"changelog.html#v0-1-2"},{"type":"extras","title":"v0.1.1 - Changelog","doc":"* New features\n  * Enable experimental feature on Windows to use prebuilt\n    port binary. Feedback appreciated.","ref":"changelog.html#v0-1-1"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"* New features\n  * Add support for adding and removing framing on data\n    transferred over the serial port.\n  * Add line framing implementation to support receiving\n    notifications only for complete lines (lines ending\n    in '\\n' or '\\r\\n') or lines that are longer than a set\n    length.\n\n* Bugs fixed\n  * Enable RTS when not using it. Keeping it cleared\n    was stopping transmission on devices that supported\n    flow control when the user wasn't using it.\n  * Fix quirks on Windows when using com0com. This should\n    improve support with at least one other serial driver\n    based on user error reports.\n\n* Known limitations\n  * Framing receive timeouts only work in active mode.\n    (I.e., you're waiting for a complete line to be received,\n    but if it takes too long, then you want to receive a\n    notification of a partial line.) Passive mode support is coming.","ref":"changelog.html#v0-1-0"},{"type":"extras","title":"v0.0.7 - Changelog","doc":"* Bugs fixed\n  * Force elixir_make v0.3.0 so that it works OTP 19","ref":"changelog.html#v0-0-7"},{"type":"extras","title":"v0.0.6 - Changelog","doc":"* New features\n  * Use elixir_make","ref":"changelog.html#v0-0-6"},{"type":"extras","title":"v0.0.5 - Changelog","doc":"* Bugs fixed\n  * Fixed enumeration of ttyACM devices on Linux","ref":"changelog.html#v0-0-5"},{"type":"extras","title":"v0.0.4 - Changelog","doc":"* New features\n  * Added hardware signal support (rts, cts, dtr, dsr, etc.)\n  * Added support for sending breaks\n  * Added support for specifying which queue to flush\n    (:receive, :transmit, or :both)\n\n* Bugs fixed\n  * Fixed crash in active mode when sending and receiving\n    at the same time","ref":"changelog.html#v0-0-4"},{"type":"extras","title":"v0.0.3 - Changelog","doc":"* Bugs fixed\n  * Crosscompiling on OSX works now","ref":"changelog.html#v0-0-3"},{"type":"extras","title":"v0.0.2 - Changelog","doc":"* Bugs fixed\n  * Fix hex.pm release by not publishing .o files","ref":"changelog.html#v0-0-2"},{"type":"extras","title":"v0.0.1 - Changelog","doc":"* Initial release","ref":"changelog.html#v0-0-1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}